﻿mpb_moveframe = UI.CreateFrame("Frame","Notification Move Frame",mpb_ui)
local mpb_notification = UI.CreateFrame("Text","Rank Up Notification Text",mpb_ui)

local mpb_starttime = 0

function MontsPrestigeBar.NotificationBuild()
	mpb_moveframe:SetVisible(false)
	mpb_moveframe:SetLayer(0)
	mpb_moveframe:SetWidth(100)
	mpb_moveframe:SetHeight(100)
	mpb_moveframe:SetBackgroundColor(0.2,0.2,0.2,0.7)
	mpb_moveframe:SetPoint("TOPLEFT",mpb_ui,"TOPLEFT",MPBSave.indicator_x,MPBSave.indicator_y)
	
	function mpb_moveframe.Event:LeftDown()
		if mpb_moveframe.fixedPos then
			return
		end
		mpb_moveframe.leftDown = true
		local mouse = Inspect.Mouse()
		mpb_moveframe.originalXDiff = mouse.x - mpb_moveframe:GetLeft()
		mpb_moveframe.originalYDiff = mouse.y - mpb_moveframe:GetTop()
		local left, top, right, bottom = mpb_moveframe:GetBounds()
	end
	function mpb_moveframe.Event:LeftUp()
		if not mpb_moveable then
			return
		end
		mpb_moveframe.leftDown = false
	end
	function mpb_moveframe.Event:LeftUpoutside()
		if not mpb_moveable then
			return
		end
		mpb_moveframe.leftDown = false
	end
	function mpb_moveframe.Event:MouseMove(x, y)
		if not mpb_moveable then
			return
		end
		if not mpb_moveframe.leftDown then
			return
		end
		local newX = x - self.originalXDiff
		local newY = y - self.originalYDiff
		mpb_moveframe:SetPoint("TOPLEFT", mpb_ui, "TOPLEFT", newX, newY)
		MPBSave.indicator_x = newX
		MPBSave.indicator_y = newY
	end
	function mpb_moveframe.Event:RightDown()
		if not mpb_moveable then
			return
		end
		mpb_moveable = false
		mpb_moveframe:SetVisible(false)
	end
	
	mpb_notification:SetLayer(1)
	mpb_notification:SetVisible(false)
	mpb_notification:SetFont("MontsPrestigeBar",MPBSave.notifont)
	mpb_notification:SetFontSize(MPBSave.indi_size)
	mpb_notification:SetFontColor(MPBSave.indi_red,MPBSave.indi_blue,MPBSave.indi_green,MPBSave.indi_alpha)
	mpb_notification:SetPoint("TOPCENTER",mpb_moveframe,"TOPCENTER",0,0)
end

function MontsPrestigeBar.RankNotification(mpb_rank_num)
	--if MPBSave.indicator then
	mpb_notification:SetText("RANK" .. " " .. tostring(mpb_rank_num))
	mpb_notification:SetVisible(true)
	--end
	mpb_starttime = Inspect.Time.Real()
end

function MontsPrestigeBar.UpTime()
	if mpb_notification:GetVisible() then
		local mpb_currtime = Inspect.Time.Real()
		if mpb_currtime >= mpb_starttime+3 then
			mpb_notification:SetVisible(false)
			mpb_notification:SetText("")
		end
	end
end

table.insert(Event.System.Update.Begin,{MontsPrestigeBar.UpTime,"MontsPrestigeBar","Show or Hide Notification"})