﻿MontsPrestigeBar = {}

mpb_ui = UI.CreateContext("Prestige Bar Context")
mpb_background = UI.CreateFrame("Texture","Prestige Bar",mpb_ui)

local mpb_fillbar = UI.CreateFrame("Frame","Fill Bar",mpb_ui)
local mpb_rank = UI.CreateFrame("Texture","Rank Texture",mpb_ui)
local mpb_ranktext = UI.CreateFrame("Text","Rank Text",mpb_ui)
local mpb_prestext = UI.CreateFrame("Text","Prestige Text",mpb_ui)

local mpb_pres_needed = 0
mpb_moveable = false

local mpb_fonts = {
				"AngloSaxon.ttf",
				"Bard.ttf",
				"Blackcha.ttf",
				"Cas_antn.ttf",
				"Casanti.ttf",
				"celticmd.ttf",
				"DANIELA.ttf",
				"DARK11.ttf",
				"demonpriest.ttf",
				"demonpriestcondital.ttf",
				"dpquake.ttf",
				"Dragon_Master.ttf",
				"ENDOR.ttf",
				"FiddumsFamily.ttf",
				"GALLA.ttf",
				"grimghost.ttf",
				"HARNGTON.ttf",
				"hobbiton.ttf",
				"Kingdom_Hearts.ttf",
				"KingthingsXander.ttf",
				"KnightsQuest.ttf",
				"NITEMARE.ttf",
				"Soul_of_Holitter.ttf",
				"Tolky.ttf",
				"VIKING.ttf",
				"VTCGoblinHand.ttf",
				"zombiecontrol.ttf"
}

function MontsPrestigeBar.Main(a)
	if a~= "MontsPrestigeBar" then
		return
	end
	if not MPBSave then
		MPBSave = {
				x = 100,
				y = 100,
				orb = true,
				red = 0,
				green = 0,
				blue = 0.8,
				alpha = 0.8,
				fontred = 1,
				fontgreen = 1,
				fontblue = 1,
				fontalpha = 1,
				indicator = false,
				indicator_x = 300,
				indicator_y = 300,
				notifont = "Fonts/grimghost.ttf",
				indi_red = 1,
				indi_blue = 1,
				indi_green = 1,
				indi_alpha = 1,
				indi_size = 60,
				favor = false,
				scale = 1
		}
	end
	if not MPBSave.orb then
		MPBSave.orb = true
	end
	if not MPBSave.indicator then
		MPBSave.indicator = false
	end
	if not MPBSave.indicator_x then
		indicator_x = 300
	end
	if not MPBSave.indicator_y then
		indicator_y = 300
	end
	if not MPBSave.notifont then
		notifont = "Fonts/grimghost.ttf"
	end
	if not MPBSave.indi_red then
		indi_red = 1
	end
	if not MPBSave.indi_blue then
		indi_blue = 1
	end
	if not MPBSave.indi_green then
		indi_green = 1
	end
	if not MPBSave.indi_alpha then
		indi_alpha = 1
	end
	if not MPBSave.indi_size then
		indi_size = 60
	end
	if not MPBSave.favor then
		MPBSave.favor = false
	end
	if not MPBSave.scale then
		MPBSave.scale = 1
	end
	MontsPrestigeBar.Build()
	MontsPrestigeBar.NotificationBuild()
	MontsPrestigeBar.FavorBarBuild()
	print("Montage's Prestige Bar has loaded.")
end

function MontsPrestigeBar.Build()
	mpb_background:SetVisible(true)
	mpb_background:SetTexture("MontsPrestigeBar","background.png")
	mpb_background:SetLayer(1)
	mpb_background:SetPoint("TOPLEFT",mpb_ui,"TOPLEFT",MPBSave.x,MPBSave.y)
	mpb_background:SetWidth(mpb_background:GetTextureWidth()*MPBSave.scale)
	mpb_background:SetHeight(mpb_background:GetTextureHeight()*MPBSave.scale)
	
	function mpb_background.Event:LeftDown()
		if mpb_background.fixedPos then
			return
		end
		mpb_background.leftDown = true
		local mouse = Inspect.Mouse()
		mpb_background.originalXDiff = mouse.x - mpb_background:GetLeft()
		mpb_background.originalYDiff = mouse.y - mpb_background:GetTop()
		local left, top, right, bottom = mpb_background:GetBounds()
	end
	function mpb_background.Event:LeftUp()
		if mpb_background.fixedPos then
			return
		end
		mpb_background.leftDown = false
	end
	function mpb_background.Event:LeftUpoutside()
		if mpb_background.fixedPos then
			return
		end
		mpb_background.leftDown = false
	end
	function mpb_background.Event:MouseMove(x, y)
		if mpb_background.fixedPos then
			return
		end
		if not mpb_background.leftDown then
			return
		end
		local newX = x - self.originalXDiff
		local newY = y - self.originalYDiff
		mpb_background:SetPoint("TOPLEFT", mpb_ui, "TOPLEFT", newX, newY)
		MPBSave.x = newX
		MPBSave.y = newY
	end
	
	mpb_fillbar:SetVisible(true)
	mpb_fillbar:SetBackgroundColor(MPBSave.red,MPBSave.green,MPBSave.blue,MPBSave.alpha)
	mpb_fillbar:SetLayer(2)
	mpb_fillbar:SetHeight(mpb_background:GetTextureHeight()*MPBSave.scale)
	mpb_fillbar:SetWidth(0)
	mpb_fillbar:SetPoint("TOPLEFT",mpb_background,"TOPLEFT",0,0)
	
	mpb_prestext:SetVisible(false)
	mpb_prestext:SetText("")
	mpb_prestext:SetLayer(3)
	mpb_prestext:SetFont("MontsPrestigeBar","celticmd.ttf")
	mpb_prestext:SetFontSize(math.ceil(17*MPBSave.scale))
	mpb_prestext:SetFontColor(MPBSave.fontred,MPBSave.fontgreen,MPBSave.fontblue,MPBSave.fontalpha)
	mpb_prestext:SetPoint("TOPLEFT",mpb_ui,"TOPLEFT",MPBSave.x,MPBSave.y)
	
	mpb_rank:SetVisible(false)
	mpb_rank:SetLayer(0)
	mpb_rank:SetTexture("MontsPrestigeBar","rank_0.png")
	mpb_rank:SetPoint("CENTERLEFT",mpb_background,"CENTERLEFT",(-mpb_rank:GetTextureWidth()+3)*MPBSave.scale,0)
	
	mpb_ranktext:SetVisible(false)
	mpb_ranktext:SetLayer(1)
	mpb_ranktext:SetFontSize(math.ceil(30*MPBSave.scale))
	mpb_ranktext:SetFontColor(1,1,1,1)
	mpb_ranktext:SetPoint("CENTER",mpb_rank,"CENTER",0,5)
end

function MontsPrestigeBar.GetPlayerInfo(mpb_unit)
	for mpd_id,mpb_specifier in pairs(mpb_unit) do
		if mpb_specifier == "player" then
			local mpb_prestige = Inspect.Pvp.Prestige()
			mpb_pres_needed = mpb_prestige.needed
			MontsPrestigeBar.TrackPrestige(mpb_prestige.accumulated,mpb_prestige.needed)
			MontsPrestigeBar.SetText(mpb_prestige.accumulated,mpb_prestige.needed)
			MontsPrestigeBar.SetRankButton(mpb_prestige.rank)
			
			if MPBSave.favor then
				local mpb_favor = Inspect.Currency.Detail("I1BE979014977916D,D836143579B97398,,,,,,")
				MontsPrestigeBar.FavorBar(mpb_favor)
			end
		end
	end
	
end

function MontsPrestigeBar.TrackPrestige(mpb_accum,mpb_needed)
	if mpb_accum then
		local mpb_percent = (mpb_accum/mpb_needed)
		mpb_fillbar:SetWidth(mpb_background:GetWidth()*mpb_percent)
	end
end

function MontsPrestigeBar.SetText(mpb_accum,mpb_needed)
	if mpb_accum then
		local mpb_percent = (mpb_accum/mpb_needed)*100
		if mpb_percent >= 10 then
			mpb_prestext:SetText(tostring(mpb_accum) .. "/" .. tostring(mpb_needed) .. " " .. "(" .. string.sub(tostring((mpb_accum/mpb_needed)*100),1,2) .. "%)")
		else
			mpb_prestext:SetText(tostring(mpb_accum) .. "/" .. tostring(mpb_needed) .. " " .. "(" .. string.sub(tostring((mpb_accum/mpb_needed)*100),1,1) .. "%)")
		end
		local left,top,right,bottom = mpb_background:GetBounds()
		local lefttext,toptext,righttext,bottomtext = mpb_prestext:GetBounds()
		local repo = (right - righttext)/2
		mpb_prestext:SetPoint("TOPLEFT",mpb_background,"TOPLEFT",repo,0)
		mpb_prestext:SetVisible(true)
	end
end

function MontsPrestigeBar.SetRankButton(mpb_rank_num)
	if MPBSave.orb then 	-- Only configure the rank orb and text if the user wants it
		if mpb_rank_num > 0 and mpb_rank_num < 10 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_0.png")
		elseif mpb_rank_num >= 10 and mpb_rank_num < 20 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_10.png")
		elseif mpb_rank_num >= 20 and mpb_rank_num < 30 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_20.png")
		elseif mpb_rank_num >= 30 and mpb_rank_num < 40 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_30.png")
		elseif mpb_rank_num >= 40 and mpb_rank_num < 50 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_40.png")
		elseif mpb_rank_num >= 50 and mpb_rank_num < 60 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_50.png")
		elseif mpb_rank_num >= 60 and mpb_rank_num < 70 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_60.png")
		elseif mpb_rank_num >= 70 and mpb_rank_num <= 80 then
			mpb_rank:SetTexture("MontsPrestigeBar","rank_70.png")
		end
		mpb_rank:SetWidth(mpb_rank:GetTextureWidth()*MPBSave.scale)
		mpb_rank:SetHeight(mpb_rank:GetTextureHeight()*MPBSave.scale)
		mpb_ranktext:ClearAll()
		local left,top,right,bottom = mpb_rank:GetBounds()
		mpb_ranktext:SetText(tostring(mpb_rank_num))
		local leftrank,toprank,rightrank,bottomrank = mpb_ranktext:GetBounds()
		local diffright = (right - rightrank)
		local diffleft = (left - leftrank)
		local difftop = (top - toprank)
		local diffbottom = (bottom - bottomrank)
		local horizrepo = diffright - diffleft
		local vertrepo = diffbottom - difftop
		local rankleft = mpb_ranktext:GetLeft()
		local ranktop = mpb_ranktext:GetTop()
		mpb_ranktext:SetPoint("TOPLEFT",mpb_rank,"TOPLEFT",horizrepo/2,vertrepo/2)
		mpb_ranktext:SetVisible(true)
		mpb_rank:SetVisible(true)
	end
end

function MontsPrestigeBar.Update(mpb_accum)
	MontsPrestigeBar.TrackPrestige(mpb_accum,mpb_pres_needed)
	MontsPrestigeBar.SetText(mpb_accum,mpb_pres_needed)
end

function MontsPrestigeBar.RankUp(mpb_rank_num)
	local mpb_info = Inspect.Pvp.Prestige()
	mpb_pres_needed = mpb_info.needed
	MontsPrestigeBar.Update(mpb_info.accumulated)
	MontsPrestigeBar.SetRankButton(mpb_rank_num)
	if MPBSave.indicator then
		MontsPrestigeBar.RankNotification(mpb_rank_num)
	end
end

function MontsPrestigeBar.SlashHandler(args)
	local cmd = {}
    local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
			cmd[numargs] = token
			numargs = numargs + 1
	end
	if cmd[0] == "orb" then
		MPBSave.orb = not MPBSave.orb
		if MPBSave.orb then
			mpb_ranktext:SetVisible(true)
			mpb_rank:SetVisible(true)
			print("Showing Rank Orb")
		else
			mpb_ranktext:SetVisible(false)
			mpb_rank:SetVisible(false)
			print("Hiding Rank Orb")
		end
	elseif cmd[0] == "default" then
		MPBSave = {
				x = 100,
				y = 100,
				orb = true,
				red = 0,
				green = 0,
				blue = 0.8,
				alpha = 0.8,
				fontred = 1,
				fontgreen = 1,
				fontblue = 1,
				fontalpha = 1,
				indicator = false,
				indicator_x = 300,
				indicator_y = 300,
				notifont = "Fonts/grimghost.ttf",
				indi_red = 1,
				indi_blue = 1,
				indi_green = 1,
				indi_alpha = 1,
				indi_size = 60,
				favor = false,
				scale = 1
		}
		MontsPrestigeBar.Build()
		MontsPrestigeBar.NotificationBuild()
		MontsPrestigeBar.GetPlayerInfo({id ="player"})
		print("Mont's Prestige Bar set to default.")
	elseif cmd[0] == "scale" then
		local mpb_scalenum = tonumber(cmd[1])
		if 0.5 <= mpb_scalenum and mpb_scalenum <= 1 then
			MPBSave.scale = mpb_scalenum
			MontsPrestigeBar.Build()
			MontsPrestigeBar.FavorBarBuild()
			MontsPrestigeBar.GetPlayerInfo({id ="player"})
			local seeifworks = Inspect.Pvp.Prestige()
			MontsPrestigeBar.SetRankButton(seeifworks.rank)
		else
			print("Please enter a number between 0.5 and 1")
		end
	elseif cmd[0] == "fillbar" then
		if 1 < tonumber(cmd[1]) < 0 or 1 < tonumber(cmd[2]) < 0 or 1 < tonumber(cmd[3]) < 0 then
			print("Please enter a number between 0 and 1 for all RGB values")
		else
			MPBSave.red = tonumber(cmd[1])
			MPBSave.green = tonumber(cmd[2])
			MPBSave.blue = tonumber(cmd[3])
			MontsPrestigeBar.Build()
			MontsPrestigeBar.GetPlayerInfo({id ="player"})
		end
	elseif cmd[0] == "fontcolor" then
		if 1 < tonumber(cmd[1]) < 0 or 1 < tonumber(cmd[2]) < 0 or 1 < tonumber(cmd[3]) < 0 then
			print("Please enter a number between 0 and 1 for all RGB values")
		else
			MPBSave.fontred = tonumber(cmd[1])
			MPBSave.fontgreen = tonumber(cmd[2])
			MPBSave.fontblue = tonumber(cmd[3])
			MontsPrestigeBar.Build()
			MontsPrestigeBar.GetPlayerInfo({id ="player"})
		end
	elseif cmd[0] == "baralpha" then
		if 1 < tonumber(cmd[1]) < 0 then
			print("Please enter a number between 0 and 1 for the alpha value")
		else
			MPBSave.alpha = tonumber(cmd[1])
			MontsPrestigeBar.Build()
			MontsPrestigeBar.GetPlayerInfo({id ="player"})
		end
	elseif cmd[0] == "fontalpha" then
		if 1 < tonumber(cmd[1]) < 0 then
			print("Please enter a number between 0 and 1 for the alpha value")
		else
			MPBSave.fontalpha = tonumber(cmd[1])
			MontsPrestigeBar.Build()
			MontsPrestigeBar.GetPlayerInfo({id ="player"})
		end
	elseif cmd[0] == "move" and cmd[1] == "noti" then
		mpb_moveable = true
		mpb_moveframe:SetVisible(true)
		print("You can now dragged the frame to position the rank up text.  Right click on the frame to lock the position.")
	elseif cmd[0] == "notifont" then
		for i=1,table.maxn(mpb_fonts),1 do
			if i == table.maxn(mpb_fonts)+1 then
				print("Not a supported font")
				break
			end
			if mpb_fonts[i] == cmd[1] then
				MPBSave.notifont = "Fonts/" .. cmd[1]
				MontsPrestigeBar.NotificationBuild()
				break
			end
		end
	elseif cmd[0] == "noticolor" then
		if 1 < tonumber(cmd[1]) < 0 or 1 < tonumber(cmd[2]) < 0 or 1 < tonumber(cmd[3]) < 0 then
			print("Please enter a number between 0 and 1 for all RGB values")
		else
			MPBSave.indi_red = tonumber(cmd[1])
			MPBSave.indi_blue = tonumber(cmd[2])
			MPBSave.indi_green = tonumber(cmd[3])
			MontsPrestigeBar.NotificationBuild()
		end
	elseif cmd[0] == "notialpha" then
		if 1 < tonumber(cmd[1]) < 0 then
			print("Please enter a number between 0 and 1 for the alpha value")
		else
			MPBSave.indi_alpha = tonumber(cmd[1])
			MontsPrestigeBar.NotificationBuild()
		end
	elseif cmd[0] == "notisize" then
		if tonumber(cmd[1]) <= 0 then
			print("Please choose a size larger than 0")
		else
			MPBSave.indi_size = tonumber(cmd[1])
			MontsPrestigeBar.NotificationBuild()
		end
	elseif cmd[0] == "rankup" then
		MPBSave.indicator = not MPBSave.indicator
		if MPBSave.indicator then
			print("Rank Up Notification Enabled")
		else
			print("Rank Up Notification Disabled")
		end
	elseif cmd[0] == "favor" then
		MPBSave.favor = not MPBSave.favor
		MontsPrestigeBar.FavorBarBuild()
		if MPBSave.favor then
			local mpb_favor = Inspect.Currency.Detail("I1BE979014977916D,D836143579B97398,,,,,,")
			MontsPrestigeBar.FavorBar(mpb_favor)
			print("Displaying Favor Bar")
		else
			print("Favor Bar is Hidden")
		end
	else
		print("Not a valid slash command for Montage's Prestige Bar.")
	end
end

table.insert(Event.Addon.Load.End,{MontsPrestigeBar.Main,"MontsPrestigeBar","Addon Load"})
table.insert(Event.Unit.Availability.Full,{MontsPrestigeBar.GetPlayerInfo,"MontsPrestigeBar","Get info when the unit is available"})
table.insert(Event.Pvp.Prestige.Accumulated,{MontsPrestigeBar.Update,"MontsPrestigeBar","Prestige has updated"})
table.insert(Event.Pvp.Prestige.Rank,{MontsPrestigeBar.RankUp,"MontsPrestigeBar","Rank Up!"})
table.insert(Command.Slash.Register("mpb"),{MontsPrestigeBar.SlashHandler,"MontsPrestigeBar","Slash Commands"})